{ $apptype console}
{$A-,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T+,V+,X+}
type
  tcode = record
    s : array[0..15] of char;
    b : array[0..3] of shortInt;
  end;
const
  nb   = 1;  {1Byte  }
  ns   = 2;  {1Byte  }
  nw   = 3;  {2Byte  }
  ni   = 4;  {2Byte  }
  cb   = 5;  {1Byte    }
  cw   = 6;  {2Byte     2-  }
  cl   = 7;  {2Byte     2-  }
  cp   = 8;  {2Byte            }
             {             -    64-   32-}
  cv   = 9;  {2Byte       -  }
  cn   = 10; {2Byte     }
  ck   = 11; {2Byte   }
  cs   = 12; {2Byte   }
  li0  = 33; {0Byte }
  lii  = 13; {1Byte     }
  lil  = 14; {1Byte      }
  lif  = 15; {1Byte       }
  lid  = 16; {1Byte       }
  lio  = 17; {1Byte      }
  si0  = 34; {0Byte }
  sii  = 18; {1Byte      }
  sil  = 19; {1Byte      }
  sif  = 20; {1Byte       }
  sid  = 21; {1Byte      }
  sio  = 22; {1Byte      }
  ac   = 23; {1Byte     }
  of2  = 24; {16-bit  }
  of4  = 25; {32-bit  }
  ofp2 = 26; {16-bit     }
  ofp4 = 27; {32-bit     }
  rtb  = 28; {8-bit      -  }
  rtw  = 29; {16-bit  }
  wide = 30; {    2Byte}
  tbs  = 31; {tableswitch}
  lks  = 32; {lookupswitch}
  pna  = 0;  {  stack-}
  pldc = 0;  {ldc- -}
  pmtd = 0;  {method- -}
  pfld = 0;  {field- -}
  pmna = 0;  {multianewarray- -}

  jbc : array[0..255] of tcode = (
{00}  (s:'nop             '; b:(0,0,0,0)),       {  }
{01}  (s:'aconst_null     '; b:(0,0,0,1)),       {   null (    )}
{02}  (s:'iconst_m1       '; b:(0,0,0,1)),       {   -1}
{03}  (s:'iconst_0        '; b:(0,0,0,1)),       {   0}
{04}  (s:'iconst_1        '; b:(0,0,0,1)),       {   1}
{05}  (s:'iconst_2        '; b:(0,0,0,1)),       {   2}
{06}  (s:'iconst_3        '; b:(0,0,0,1)),       {   3}
{07}  (s:'iconst_4        '; b:(0,0,0,1)),       {   4}
{08}  (s:'iconst_5        '; b:(0,0,0,1)),       {   5}
{09}  (s:'lconst_0        '; b:(0,0,0,2)),       {    0}
{0A}  (s:'lconst_1        '; b:(0,0,0,2)),       {    1}
{0B}  (s:'fconst_0        '; b:(0,0,0,1)),       {     0}
{0C}  (s:'fconst_1        '; b:(0,0,0,1)),       {     1}
{0D}  (s:'fconst_2        '; b:(0,0,0,1)),       {     2}
{0E}  (s:'dconst_0        '; b:(0,0,0,2)),       {     0}
{0F}  (s:'dconst_1        '; b:(0,0,0,2)),       {     1}
{10}  (s:'bipush          '; b:(nb,0,0,1{+1})),  {1,      }
{11}  (s:'sipush          '; b:(ni,0,0,1{+1})),  {2,      }
{12}  (s:'ldc1            '; b:(cb,0,0,1)),      {1,      }
{13}  (s:'ldc2            '; b:(cw,0,0,1{pldc})),{2,      }
{14}  (s:'ldc2w           '; b:(cl,0,0,2{pldc})),{2,      }
                                                 {      }
{15}  (s:'iload           '; b:(lii,0,0,1)),     {1,    }
{16}  (s:'lload           '; b:(lil,0,0,2)),     {1,     }
{17}  (s:'fload           '; b:(lif,0,0,1)),     {1,      }
{18}  (s:'dload           '; b:(lid,0,0,2)),     {1,      }
{19}  (s:'aload           '; b:(lio,0,0,1)),     {1,     }
{1A}  (s:'iload_0         '; b:(li0,0,0,1{pna})),   {     0}
{1B}  (s:'iload_1         '; b:(li0,0,0,1{pna})),   {     1}
{1C}  (s:'iload_2         '; b:(li0,0,0,1{pna})),   {     2}
{1D}  (s:'iload_3         '; b:(li0,0,0,1{pna})),   {     3}
{1E}  (s:'lload_0         '; b:(li0,0,0,2{pna})),   {      0}
{1F}  (s:'lload_1         '; b:(li0,0,0,2{pna})),   {      1}
{20}  (s:'lload_2         '; b:(li0,0,0,2{pna})),   {      2}
{21}  (s:'lload_3         '; b:(li0,0,0,2{pna})),   {      3}
{22}  (s:'fload_0         '; b:(li0,0,0,1{pna})),   {       0}
{23}  (s:'fload_1         '; b:(li0,0,0,1{pna})),   {       1}
{24}  (s:'fload_2         '; b:(li0,0,0,1{pna})),   {       2}
{25}  (s:'fload_3         '; b:(li0,0,0,1{pna})),   {       3}
{26}  (s:'dload_0         '; b:(li0,0,0,2{pna})),   {       0}
{27}  (s:'dload_1         '; b:(li0,0,0,2{pna})),   {       1}
{28}  (s:'dload_2         '; b:(li0,0,0,2{pna})),   {       2}
{29}  (s:'dload_3         '; b:(li0,0,0,2{pna})),   {       3}
{2A}  (s:'aload_0         '; b:(li0,0,0,1{pna})),   {      0}
{2B}  (s:'aload_1         '; b:(li0,0,0,1{pna})),   {      1}
{2C}  (s:'aload_2         '; b:(li0,0,0,1{pna})),   {      2}
{2D}  (s:'aload_3         '; b:(li0,0,0,1{pna})),   {      3}
{2E}  (s:'iaload          '; b:(0,0,0,-1)),      {   }
{2F}  (s:'laload          '; b:(0,0,0,0)),       {    }
{30}  (s:'faload          '; b:(0,0,0,-1)),      {   }
{31}  (s:'daload          '; b:(0,0,0,0)),       {    }
{32}  (s:'aaload          '; b:(0,0,0,-1)),      {    }
{33}  (s:'baload          '; b:(0,0,0,-1)),      {     }
{34}  (s:'caload          '; b:(0,0,0,-1)),      {   }
{35}  (s:'saload          '; b:(0,0,0,-1)),      {   }
{36}  (s:'istore          '; b:(sii,0,0,-1)),    {1,     }
{37}  (s:'lstore          '; b:(sil,0,0,-2)),    {1,     }
{38}  (s:'fstore          '; b:(sif,0,0,-1)),    {1,      }
{39}  (s:'dstore          '; b:(sid,0,0,-2)),    {1,     }
{3A}  (s:'astore          '; b:(sio,0,0,-1)),    {1,     }
{3B}  (s:'istore_0        '; b:(si0,0,0,-1{pna})),   {     0}
{3C}  (s:'istore_1        '; b:(si0,0,0,-1{pna})),   {     1}
{3D}  (s:'istore_2        '; b:(si0,0,0,-1{pna})),   {     2}
{3E}  (s:'istore_3        '; b:(si0,0,0,-1{pna})),   {     3}
{3F}  (s:'lstore_0        '; b:(si0,0,0,-2{pna})),   {      0}
{40}  (s:'lstore_1        '; b:(si0,0,0,-2{pna})),   {      1}
{41}  (s:'lstore_2        '; b:(si0,0,0,-2{pna})),   {      2}
{42}  (s:'lstore_3        '; b:(si0,0,0,-2{pna})),   {      3}
{43}  (s:'fstore_0        '; b:(si0,0,0,-1{pna})),   {       0}
{44}  (s:'fstore_1        '; b:(si0,0,0,-1{pna})),   {       1}
{45}  (s:'fstore_2        '; b:(si0,0,0,-1{pna})),   {       2}
{46}  (s:'fstore_3        '; b:(si0,0,0,-1{pna})),   {       3}
{47}  (s:'dstore_0        '; b:(si0,0,0,-2{pna})),   {      0}
{48}  (s:'dstore_1        '; b:(si0,0,0,-2{pna})),   {      1}
{49}  (s:'dstore_2        '; b:(si0,0,0,-2{pna})),   {      2}
{4A}  (s:'dstore_3        '; b:(si0,0,0,-2{pna})),   {      3}
{4B}  (s:'astore_0        '; b:(si0,0,0,-1{pna})),   {      0}
{4C}  (s:'astore_1        '; b:(si0,0,0,-1{pna})),   {      1}
{4D}  (s:'astore_2        '; b:(si0,0,0,-1{pna})),   {      2}
{4E}  (s:'astore_3        '; b:(si0,0,0,-1{pna})),   {      3}
{4F}  (s:'iastore         '; b:(0,0,0,-3)),      {   }
{50}  (s:'lastore         '; b:(0,0,0,-4)),      {     }
{51}  (s:'fastore         '; b:(0,0,0,-3)),      {     }
{52}  (s:'dastore         '; b:(0,0,0,-4)),      {     }
{53}  (s:'aastore         '; b:(0,0,0,-3)),      {     }
{54}  (s:'bastore         '; b:(0,0,0,-3)),      {     }
{55}  (s:'castore         '; b:(0,0,0,-3)),      {   }
{56}  (s:'sastore         '; b:(0,0,0,-3)),      {     }
{57}  (s:'pop             '; b:(0,0,0,-1)),      {    }
{58}  (s:'pop2            '; b:(0,0,0,-2)),      {     }
{59}  (s:'dup             '; b:(0,0,0,1)),       {    }
{5A}  (s:'dup_x1          '; b:(0,0,0,1)),       {    }
                                                 {          }
{5B}  (s:'dup_x2          '; b:(0,0,0,1)),       {         }
{5C}  (s:'dup2            '; b:(0,0,0,2)),       {     }
{5D}  (s:'dup2_x1         '; b:(0,0,0,2)),       {            }
{5E}  (s:'dup2_x2         '; b:(0,0,0,2)),       {            }
{5F}  (s:'swap            '; b:(0,0,0,0)),       {     }
{60}  (s:'iadd            '; b:(0,0,0,-1)),      { }
{61}  (s:'ladd            '; b:(0,0,0,-2)),      {  }
{62}  (s:'fadd            '; b:(0,0,0,-1)),      {  }
{63}  (s:'dadd            '; b:(0,0,0,-2)),      {  }
{64}  (s:'isub            '; b:(0,0,0,-1)),      { }
{65}  (s:'lsub            '; b:(0,0,0,-2)),      {  }
{66}  (s:'fsub            '; b:(0,0,0,-1)),      {  }
{67}  (s:'dsub            '; b:(0,0,0,-2)),      {  }
{68}  (s:'imul            '; b:(0,0,0,-1)),      { }
{69}  (s:'lmul            '; b:(0,0,0,-2)),      {  }
{6A}  (s:'fmul            '; b:(0,0,0,-1)),      {  }
{6B}  (s:'dmul            '; b:(0,0,0,-2)),      {  }
{6C}  (s:'idiv            '; b:(0,0,0,-1)),      { }
{6D}  (s:'ldiv            '; b:(0,0,0,-2)),      {  }
{6E}  (s:'fdiv            '; b:(0,0,0,-1)),      {  }
{6F}  (s:'ddiv            '; b:(0,0,0,-2)),      {  }
{70}  (s:'irem            '; b:(0,0,0,-1)),      {   }
{71}  (s:'lrem            '; b:(0,0,0,-2)),      {    }
{72}  (s:'frem            '; b:(0,0,0,-1)),      {    }
{73}  (s:'drem            '; b:(0,0,0,-2)),      {    }
{74}  (s:'ineg            '; b:(0,0,0,0)),       { }
{75}  (s:'leg             '; b:(0,0,0,0)),       {  }
{76}  (s:'fneg            '; b:(0,0,0,0)),       {  }
{77}  (s:'dneg            '; b:(0,0,0,0)),       {   }
{78}  (s:'ishl            '; b:(0,0,0,-1)),      {  }
{79}  (s:'lshl            '; b:(0,0,0,-1)),      {   }
{7A}  (s:'ishr            '; b:(0,0,0,-1)),      {   }
{7B}  (s:'lshr            '; b:(0,0,0,-1)),      {    }
{7C}  (s:'iushr           '; b:(0,0,0,-1)),      {   }
{7D}  (s:'lushr           '; b:(0,0,0,-1)),      {    }
{7E}  (s:'iand            '; b:(0,0,0,-1)),      {     }
{7F}  (s:'land            '; b:(0,0,0,-2)),      {      }
{80}  (s:'ior             '; b:(0,0,0,-1)),      {    }
{81}  (s:'lor             '; b:(0,0,0,-2)),      {      }
{82}  (s:'ixor            '; b:(0,0,0,-1)),      {    }
{83}  (s:'lxor            '; b:(0,0,0,-2)),      {      }
{84}  (s:'iinc            '; b:(ac,ns,0,0)),     {2,    }
{85}  (s:'i2l             '; b:(0,0,0,1)),       {    }
{86}  (s:'i2f             '; b:(0,0,0,0)),       {  }
{87}  (s:'i2d             '; b:(0,0,0,1)),       {   }
{88}  (s:'l2i             '; b:(0,0,0,-1)),      {   }
{89}  (s:'l2f             '; b:(0,0,0,-1)),      {   }
{8A}  (s:'l2d             '; b:(0,0,0,0)),       {    }
{8B}  (s:'f2i             '; b:(0,0,0,0)),       {  }
{8C}  (s:'f2l             '; b:(0,0,0,1)),       {   }
{8D}  (s:'f2d             '; b:(0,0,0,1)),       {   }
{8E}  (s:'d2i             '; b:(0,0,0,-1)),      {   }
{8F}  (s:'d2l             '; b:(0,0,0,0)),       {    }
{90}  (s:'d2f             '; b:(0,0,0,-1)),      {   }
{91}  (s:'int2byte        '; b:(0,0,0,0)),       {   }
{92}  (s:'int2char        '; b:(0,0,0,0)),       {  }
{93}  (s:'int2short       '; b:(0,0,0,0)),       {  }
{94}  (s:'lcmp            '; b:(0,0,0,-3)),      {  }
{95}  (s:'fcmpl           '; b:(0,0,0,-1)),      {    (-1  NaN)}
{96}  (s:'fcmpg           '; b:(0,0,0,-1)),      {    (1  NaN)}
{97}  (s:'dcmpl           '; b:(0,0,0,-3)),      {   (-1  NaN)}
{98}  (s:'dcmpg           '; b:(0,0,0,-3)),      {   (1  NaN)}
{99}  (s:'ifeq            '; b:(of2,0,0,-1)),    {2,,   0}
{9A}  (s:'ifne            '; b:(of2,0,0,-1)),    {2,,    0}
{9B}  (s:'iflt            '; b:(of2,0,0,-1)),    {2,,   0}
{9C}  (s:'ifge            '; b:(of2,0,0,-1)),    {2,,     0}
{9D}  (s:'ifgt            '; b:(of2,0,0,-1)),    {2,,   0}
{9E}  (s:'ifle            '; b:(of2,0,0,-1)),    {2,,     0}
{9F}  (s:'if_icmpeq       '; b:(of2,0,0,-2)),    {2,,   }
{A0}  (s:'if_icmpne       '; b:(of2,0,0,-2)),    {2,,    }
{A1}  (s:'if_icmplt       '; b:(of2,0,0,-2)),    {2,,    0}
{A2}  (s:'if_icmpge       '; b:(of2,0,0,-2)),    {2,,     }
{A3}  (s:'if_icmpgt       '; b:(of2,0,0,-2)),    {2,,    0}
{A4}  (s:'if_icmple       '; b:(of2,0,0,-2)),    {2,,     }
{A5}  (s:'if_acmpeq       '; b:(of2,0,0,-2)),    {2,,     }
{A6}  (s:'if_acmpne       '; b:(of2,0,0,-2)),    {2,,      }
{A7}  (s:'goto            '; b:(of2,0,0,0)),     {2, }
{A8}  (s:'jsr             '; b:(ofp2,0,0,1{+1})),{2,  }
{A9}  (s:'ret             '; b:(rtb,0,0,0)),     {1,  }
{AA}  (s:'tableswitch     '; b:(tbs,0,0,-1{-1})),{       }
{AB}  (s:'lookupswitch    '; b:(lks,0,0,-1{-1})),{         }
{AC}  (s:'ireturn         '; b:(0,0,0,-1)),      {   }
{AD}  (s:'lreturn         '; b:(0,0,0,-2)),      {    }
{AE}  (s:'freturn         '; b:(0,0,0,-1)),      {    }
{AF}  (s:'dreturn         '; b:(0,0,0,-2)),      {    }
{B0}  (s:'areturn         '; b:(0,0,0,-1)),      {    }
{B1}  (s:'return          '; b:(0,0,0,0)),       {()  }
{B2}  (s:'getstatic       '; b:(cp,0,0,pfld)),   {2,   }
{B3}  (s:'putstatic       '; b:(cp,0,0,pfld)),   {2,    }
{B4}  (s:'getfield        '; b:(cp,0,0,pfld)),   {2,   }
{B5}  (s:'putfield        '; b:(cp,0,0,pfld)),   {2,   }
{B6}  (s:'invokevirtual   '; b:(cv,0,0,pmtd)),   {2,  ,     }
{B7}  (s:'invokenonvirtual'; b:(cv,0,0,pmtd)),   {2,  ,     }
{B8}  (s:'invokestatic    '; b:(cv,0,0,pmtd)),   {2,   ( )}
{B9}  (s:'invokeinterface '; b:(cv,nb,nb,pna)),   {4,  }
{BA}  (s:'                '; b:(0,0,0,0)),       {}
{BB}  (s:'new             '; b:(cn,0,0,1{+1})),  {2,  }
{BC}  (s:'newarray        '; b:(nb,0,0,0)),      {1,atype> T_BOOLEAN=4,T_CHAR=5,T_FLOAT=6,T_DOUBLE=7,T_BYTE=8,}
                                                 {  T_SHORT=9,T_INT=9,T_LONG=11}
{BD}  (s:'anewarray       '; b:(ck,0,0,0)),      {2,      }
{BE}  (s:'arraylength     '; b:(0,0,0,0)),       {  }
{BF}  (s:'athrow          '; b:(0,0,0,pna)),     {   }
{C0}  (s:'checkcast       '; b:(cs,0,0,0)),      {2,,     }
{C1}  (s:'instanceof      '; b:(ck,0,0,0)),      {2,,     }
{C2}  (s:'monitorenter    '; b:(0,0,0,-1)),      {    }
{C3}  (s:'monitorexit     '; b:(0,0,0,-1)),      {    }
{C4}  (s:'wide            '; b:(wide,0,0,pna)),  {1,       }
                                                 {   ,   }
{C5}  (s:'multianewarray  '; b:(cn,nb,0,pmna)),  {3,   }
{C6}  (s:'ifnull          '; b:(of2,0,0,-1)),    {2,,   }
{C7}  (s:'ifnonnull       '; b:(of2,0,0,-1)),    {2,,    }
{C8}  (s:'goto_w          '; b:(of4,0,0,0)),     {4,  ( )}
{C9}  (s:'jsr_w           '; b:(ofp4,0,0,0)),    {4,   ( )}
{CA}  (s:'breakpoint      '; b:(0,0,0,0)),       {     }
{CB}  (s:'                '; b:(0,0,0,0)),       {}
{CC}  (s:'                '; b:(0,0,0,0)),       {}
{CD}  (s:'                '; b:(0,0,0,0)),       {}
{CE}  (s:'                '; b:(0,0,0,0)),       {}
{CF}  (s:'                '; b:(0,0,0,0)),       {}
{D0}  (s:'                '; b:(0,0,0,0)),       {}
{D1}  (s:'ret_w           '; b:(rtw,0,0,0)),     {2,   ( )}
{D2}  (s:'                '; b:(0,0,0,0)),       {}
{D3}  (s:'                '; b:(0,0,0,0)),       {}
{D4}  (s:'                '; b:(0,0,0,0)),       {}
{D5}  (s:'                '; b:(0,0,0,0)),       {}
{D6}  (s:'                '; b:(0,0,0,0)),       {}
{D7}  (s:'                '; b:(0,0,0,0)),       {}
{D8}  (s:'                '; b:(0,0,0,0)),       {}
{D9}  (s:'                '; b:(0,0,0,0)),       {}
{DA}  (s:'                '; b:(0,0,0,0)),       {}
{DB}  (s:'                '; b:(0,0,0,0)),       {}
{DC}  (s:'                '; b:(0,0,0,0)),       {}
{DD}  (s:'                '; b:(0,0,0,0)),       {}
{DE}  (s:'                '; b:(0,0,0,0)),       {}
{DF}  (s:'                '; b:(0,0,0,0)),       {}
{E0}  (s:'                '; b:(0,0,0,0)),       {}
{E1}  (s:'                '; b:(0,0,0,0)),       {}
{E2}  (s:'                '; b:(0,0,0,0)),       {}
{E3}  (s:'                '; b:(0,0,0,0)),       {}
{E4}  (s:'                '; b:(0,0,0,0)),       {}
{E5}  (s:'                '; b:(0,0,0,0)),       {}
{E6}  (s:'                '; b:(0,0,0,0)),       {}
{E7}  (s:'                '; b:(0,0,0,0)),       {}
{E8}  (s:'                '; b:(0,0,0,0)),       {}
{E9}  (s:'                '; b:(0,0,0,0)),       {}
{EA}  (s:'                '; b:(0,0,0,0)),       {}
{EB}  (s:'                '; b:(0,0,0,0)),       {}
{EC}  (s:'                '; b:(0,0,0,0)),       {}
{ED}  (s:'                '; b:(0,0,0,0)),       {}
{EE}  (s:'                '; b:(0,0,0,0)),       {}
{EF}  (s:'                '; b:(0,0,0,0)),       {}
{F0}  (s:'                '; b:(0,0,0,0)),       {}
{F1}  (s:'                '; b:(0,0,0,0)),       {}
{F2}  (s:'                '; b:(0,0,0,0)),       {}
{F3}  (s:'                '; b:(0,0,0,0)),       {}
{F4}  (s:'                '; b:(0,0,0,0)),       {}
{F5}  (s:'                '; b:(0,0,0,0)),       {}
{F6}  (s:'                '; b:(0,0,0,0)),       {}
{F7}  (s:'                '; b:(0,0,0,0)),       {}
{F8}  (s:'                '; b:(0,0,0,0)),       {}
{F9}  (s:'                '; b:(0,0,0,0)),       {}
{FA}  (s:'                '; b:(0,0,0,0)),       {}
{FB}  (s:'                '; b:(0,0,0,0)),       {}
{FC}  (s:'                '; b:(0,0,0,0)),       {}
{FD}  (s:'                '; b:(0,0,0,0)),       {}
{FE}  (s:'                '; b:(0,0,0,0)),       {}
{FF}  (s:'                '; b:(0,0,0,0)));      {}
const
  ACC_PUBLIC       = 1;
  ACC_PRIVATE      = 2;
  ACC_PROTECTED    = 4;
  ACC_STATIC       = 8;
  ACC_FINAL        = 16;
  ACC_SYNCHRONIZED = 32;
  ACC_SUPER        = 32;
  ACC_VOLATILE     = 64;
  ACC_TRANSIENT    = 128;
  ACC_NATIVE       = 256;
  ACC_INTERFACE    = 512;
  ACC_ABSTRACT     = 1024;
  {-}
  CONSTANT_any     = 0;
  CONSTANT_Utf8    = 1;
  CONSTANT_Unicode = 2;
  CONSTANT_Integer = 3;
  CONSTANT_Float   = 4;
  CONSTANT_Long    = 5;
  CONSTANT_Double  = 6;
  CONSTANT_Class   = 7;
  CONSTANT_String  = 8;
  CONSTANT_Fieldref = 9;
  CONSTANT_Methodref = 10;
  CONSTANT_InterfaceMethodref = 11;
  CONSTANT_NameAndType = 12;
type
  tarr=array[0..$FFFF-1] of byte;
  tvar=array[0..255] of record
    name : string[50];
    typ  : string[203];
  end;
var
  cf : record {ClassFile}
    magic               : longInt;
    minor_version       : word;
    major_version       : word;
    constant_pool_count : word;
    cp_info             :^tarr;    {[constant_pool_count-1]}
    access_flags        : word;
    this_class          : word;
    super_class         : word;
    interfaces_count    : word;
    interfaces          :^tarr;    {[interfaces_count]}
    fields_count        : word;
    field_info          :^tarr;    {fields[fields_count]}
    methods_count       : word;
    method_info         :^tarr;    {methods[methods_count]}
    attributes_count    : word;
    attribute_info      :^tarr;    {attributes[attribute_count]}
    vartab              :^tvar;    {   }
    pc,pi,pf,pm,pa,pvar,ntab,psm : integer; {   }
    attribute_lengthtPtr:^longInt; {   }
    max_localsPtr       :^word;    {  -  }
    code_lengthPtr      :^longInt; {    }
    stackMap            :^tarr;    {StackMap - ,  }
    stackMapEntries     :^word;
    byteCodeOffsPtr     :^word;    {   byteCodeOffs}
    numLocStackPtr      :^word;    {   -   StackMap}
    loc_or_stack        : byte;    {  StackMap}
    maxStack            :^word;
    curStack            : integer;
  end;
  f            : file;       { -}
  s            : string;     {      .}
  pl1,pl2      :^longInt;    {temp-4Byte    }
  pw1,pw2      :^word;       {temp-2Byte    }
  i,j          : integer;    { }
  strNum,strPos: integer;    {   }
  ch           : char;       {   }


procedure error(msg : string);
begin  {   }
  write('(str:',strNum,' pos:',strPos, ') ERROR: '+msg);
  readln;
  halt;
end;


procedure getc;
var    {    }
  n : integer;
begin
  blockRead(f,ch,1,n);
  if n=0 then ch:=#255                         {End Of File}
    else if ch<>#10 then inc(strPos)           {Next pos}
      else begin inc(strNum); strPos:=0; end;  {Next str}
end;


procedure skipSpaces;
begin  {       .}
  while (ch<=#32) or (ch='{') do
  begin
    if ch='{' then repeat getc; until (ch='}'){ or (ch=#255){};
    getc;
  end;
end;


procedure skip(c:char);
begin  { }
  skipSpaces;
  if (ch<>c) {or (ch<>#255){} then error('char not found: "'+c+'"');
  getc;
end;


function getn : longInt;
const  {   4- , (   )}
  h : array[0..15] of char = '0123456789ABCDEF';
var
  l : longInt;
  i : integer;
  z : char;
begin
  l:=0;
  skipSpaces;
  z:='+';
  if ch in ['+','-'] then begin z:=ch; getc; end;
  skipSpaces;
  if ch='$' then
  begin
    getc;
    while ch in ['0'..'9','A'..'F'] do
    begin
      for i := 0 to 15 do
        if h[i]=ch then l := (l shl 4) + i;
      getc;
    end;
  end
  else
  begin
    while ch in ['0'..'9'] do
    begin
      l:=l*10+(ord(ch)-ord('0'));
      getc;
    end;
  end;
  if (z='-') then l:=-l;  { ,   }
  getn := l;
end;


function gets : string;
var    { }
  s : string;
begin
  s:='';
  skipSpaces;
  while ch in ['_','/',';','(',')','<','>','0'..'9','A'..'Z','a'..'z'] do
  begin
    s:=s+ch;
    getc;
  end;
  gets := s;
end;


function getb : string;
var    {     }
  s : string;
begin
  s:='';
  skip('"');
  while (ch<>'"') do
  begin
    s:=s+ch;
    getc;
    if (ch=#13) then error('not found ''"''');
  end;
  getc;
  getb := s;
end;


function swap2(n : word) : word;
var    {   }
  b : array[0..1] of byte absolute n;
  t : byte;
begin
  t:=b[0]; b[0]:=b[1]; b[1]:=t;
  swap2 := n;
end;


function swap4(n : longInt) : longInt;
var    {    4-  }
  b : array[0..3] of byte absolute n;
  t : byte;
begin
  t:=b[0]; b[0]:=b[3]; b[3]:=t;
  t:=b[1]; b[1]:=b[2]; b[2]:=t;
  swap4 := n;
end;


function constfind(typ:byte; name:string; index:word; w1,w2:word; l1,l2:longInt) : word;{}
{  typ  ,    "<init>",   
   : "w1" "w2" "l1" "l2".
 : CONSTANT_Fieldref, CONSTANT_Methodref, CONSTANT_InterfaceMethodref
-   }
var
  s     : string;     {temp-    }
  i,n,p : integer;
begin
  w1:=swap2(w1);
  w2:=swap2(w2);
  l1:=swap4(l1);
  l2:=swap4(l2);
  if (typ in [CONSTANT_Fieldref,CONSTANT_Methodref,CONSTANT_InterfaceMethodref])
  or ((name='<init>') and (typ=CONSTANT_NameAndType)) then name:='';
  p:=0;
  i:=1;
  while i<=cf.constant_pool_count do
  begin
    n:=byte(cf.cp_info^[p]);
    inc(p);
    s:='';
    if i=57 then
    writeln;
    while (n>0) do
    begin
      s:=s+chr(cf.cp_info^[p]);
      inc(p);
      dec(n);
    end;
    cf.pvar:=p;
    if ((typ=cf.cp_info^[p]) or (typ=CONSTANT_any))
    and ((s=name) and (name<>'')) then
    begin
      constfind := i;
      exit;
    end;
    if (i=index) then
    begin
      constfind := i;
      exit;
    end;
    {-}
    case cf.cp_info^[p] of
      CONSTANT_Class:
        if typ=CONSTANT_Class then
        begin
          inc(p);
          pw1:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          if (pw1^=w1) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+2);
      CONSTANT_Fieldref:
        if typ=CONSTANT_Fieldref then
        begin
          inc(p);
          pw1:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          pw2:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_Methodref:
        if typ=CONSTANT_Methodref then
        begin
          inc(p);
          pw1:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          pw2:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_InterfaceMethodref:
        if typ=CONSTANT_InterfaceMethodref then
        begin
          inc(p);
          pw1:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          pw2:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_String:
        if typ=CONSTANT_String then
        begin
          inc(p);
          pw1:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          if (pw1^=w1) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+2);
      CONSTANT_Integer,
      CONSTANT_Float:
        if typ in [CONSTANT_Integer,CONSTANT_Float] then
        begin
          inc(p);
          pl1:=pointer(@cf.cp_info^[p]);
          inc(p,4);
          if (pl1^=l1) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_Long,CONSTANT_Double:
        if typ in [CONSTANT_Long,CONSTANT_Double] then
        begin
          inc(p);
          pl1:=pointer(@cf.cp_info^[p]);
          inc(p,4);
          pl2:=pointer(@cf.cp_info^[p]);
          inc(p,4);
          if (pl1^=l1) and (pl2^=l2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else begin inc(p,1+8 ); inc(i); end; {    2-   constant_pool}
      CONSTANT_NameAndType:
        if typ=CONSTANT_NameAndType then
        begin
          inc(p);
          pw1:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          pw2:=pointer(@cf.cp_info^[p]);
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_Utf8, CONSTANT_Unicode:
        begin      {null=$0000, 1b=$0001-$007F,2b=$0008-$07FF,3b=$0800-$FFFF{}
          inc(p);
          pw1:=pointer(@cf.cp_info^[p]);
          n:=swap2(pw1^);
          inc(p,2);
          if typ in [CONSTANT_Utf8, CONSTANT_Unicode] then
          begin
            s:='';
            while n>0 do
            begin
              s:=s+chr(cf.cp_info^[p]);
              inc(p);
              dec(n);
            end;
            if (s=name) then {      }
            begin
              constfind := i;
              exit;
            end;
          end
          else inc(p,n);
        end;
    end;
    inc(i);
  end;
  constfind := 0;  {   }
end;


function constadd(typ:byte; name,str:string; num : longInt) : word; {pascal; {- Delphi,  -}
{    ,    }
var
  i     : integer;
  w1,w2 : word;
begin
  constadd := 0;
  i:=constfind(typ,name,0,0,0,0,0);
  if (i>0) then
  begin
    constadd := i;
    exit;
  end;
  case typ of
    CONSTANT_Utf8,CONSTANT_Unicode:
      begin
        w1:=constfind(CONSTANT_Utf8,str,0,0,0,0,0); {   }
        if w1=0 then
        begin
          cf.cp_info^[cf.pc]:=length(name); {..   ,}
          inc(cf.pc);               {    }
          for i := 1 to length(name) do {,   }
          begin
            cf.cp_info^[cf.pc] := ord(name[i]);
            inc(cf.pc);
          end;
          cf.pvar:=cf.pc;       {cf.pvar <-    }
          cf.cp_info^[cf.pc]:=typ;
          inc(cf.pc);
          {}
          pw1:=pointer(@cf.cp_info^[cf.pc]);
          i:=length(str);
          pw1^:=swap2(i);
          inc(cf.pc,2);
          for i := 1 to length(str) do
          begin
            cf.cp_info^[cf.pc] := ord(str[i]);
            inc(cf.pc);
          end;
          inc(cf.constant_pool_count);
          constadd := cf.constant_pool_count;
        end
          else constadd := w1;
      end;
    CONSTANT_Integer,
    CONSTANT_Float:
      begin
        w1:=constfind(typ,'',0,0,0,num,0);
        if w1=0 then
        begin
          cf.cp_info^[cf.pc]:=length(name);
          inc(cf.pc);
          for i := 1 to length(name) do
          begin
            cf.cp_info^[cf.pc] := ord(name[i]);
            inc(cf.pc);
          end;
          cf.pvar:=cf.pc;
          cf.cp_info^[cf.pc]:=typ;
          inc(cf.pc);
          {}
          pl1:=pointer(@cf.cp_info^[cf.pc]);
          pl1^:=swap4(num);
          inc(cf.pc,4);
          inc(cf.constant_pool_count);
          constadd := cf.constant_pool_count;
        end
          else constadd := w1;
      end;
    CONSTANT_Long,
    CONSTANT_Double:    { ,  }
      begin
        {...} {    2-   constant_pool}
        {inc(cf.constant_pool_count,2); constadd := cf.constant_pool_count;}
      end;
    CONSTANT_Class:
      begin
        w1:=constadd(CONSTANT_Utf8,'',str,0);
        w2:=constfind(CONSTANT_Class,'',0,w1,0,0,0);
        if w2=0 then
        begin
          cf.cp_info^[cf.pc]:=length(name);
          inc(cf.pc);
          for i := 1 to length(name) do
          begin
            cf.cp_info^[cf.pc] := ord(name[i]);
            inc(cf.pc);
          end;
          cf.pvar:=cf.pc;
          cf.cp_info^[cf.pc]:=typ;
          inc(cf.pc);
          {}
          pw1:=pointer(@cf.cp_info^[cf.pc]);
          pw1^:=swap2(w1);
          inc(cf.pc,2);
          inc(cf.constant_pool_count);
          constadd := cf.constant_pool_count;
        end
          else constadd := w2;
      end;
    CONSTANT_String:
      begin
        w1:=constadd(CONSTANT_Utf8,'',str,0);
        w2:=constfind(CONSTANT_String,'',0,w1,0,0,0);
        if (w2=0) then
        begin
          cf.cp_info^[cf.pc]:=length(name);
          inc(cf.pc);
          for i := 1 to length(name) do
          begin
            cf.cp_info^[cf.pc] := ord(name[i]);
            inc(cf.pc);
          end;
          cf.pvar:=cf.pc;
          cf.cp_info^[cf.pc]:=typ;
          inc(cf.pc);
          {}
          pw1:=pointer(@cf.cp_info^[cf.pc]);
          pw1^:=swap2(w1);
          inc(cf.pc,2);
          inc(cf.constant_pool_count);
          constadd := cf.constant_pool_count;
        end
         else constadd := w2;
      end;
    CONSTANT_Fieldref,
    CONSTANT_Methodref,
    CONSTANT_InterfaceMethodref:
      begin
        {s:='';
        for i := 1 to length(name) do
          if not (name[i] in ['_']) then s:=s+name[i]
            else s:=s+'/';
        w1:=constadd(CONSTANT_Class,s,name);{}
        w1:=constfind(CONSTANT_Class,name,0,0,0,0,0);
        w2:=num;
        if str<>'' then w2:=constfind(CONSTANT_NameAndType,str,0,0,0,0,0);
        if (w1=0) then error('class "'+name+'" not found') else
        if (w2=0) then error('NameAndType "'+str+'" not found') else
        begin
          i:=constfind(typ,'',0,w1,w2,0,0);
          if i=0 then
          begin
            cf.cp_info^[cf.pc]:=length(name);
            inc(cf.pc);
            for i := 1 to length(name) do
            begin
              cf.cp_info^[cf.pc] := ord(name[i]);
              inc(cf.pc);
            end;
            cf.pvar:=cf.pc;
            cf.cp_info^[cf.pc]:=typ;
            inc(cf.pc);
            {}
            pw1:=pointer(@cf.cp_info^[cf.pc]);
            pw1^:=swap2(w1);
            inc(cf.pc,2);
            pw1:=pointer(@cf.cp_info^[cf.pc]);
            pw1^:=swap2(w2);
            inc(cf.pc,2);
            inc(cf.constant_pool_count);
            constadd := cf.constant_pool_count;
          end
            else constadd := i;
        end;
      end;
    CONSTANT_NameAndType:
      begin
        w1:=constadd(CONSTANT_Utf8,'',name,0);
        w2:=constadd(CONSTANT_Utf8,'',str,0);
        i:=constfind(CONSTANT_NameAndType,'',0,w1,w2,0,0);
        if i=0 then
        begin
          cf.cp_info^[cf.pc]:=length(name);
          inc(cf.pc);
          for i := 1 to length(name) do
          begin
            cf.cp_info^[cf.pc] := ord(name[i]);
            inc(cf.pc);
          end;
          cf.pvar:=cf.pc;
          cf.cp_info^[cf.pc]:=typ;
          inc(cf.pc);
          {}
          pw1:=pointer(@cf.cp_info^[cf.pc]);
          pw1^:=swap2(w1);
          inc(cf.pc,2);
          pw1:=pointer(@cf.cp_info^[cf.pc]);
          pw1^:=swap2(w2);
          inc(cf.pc,2);
          inc(cf.constant_pool_count);
          constadd := cf.constant_pool_count;
        end
          else constadd := i;
      end;
  end;
end;


function flags(s : string) : word;
var    {   -}
  f : word;
begin
  f := 0;
  if pos('PUBLIC',s)>0       then f := f or 1;
  if pos('PRIVATE',s)>0      then f := f or 2;
  if pos('PROTECTED',s)>0    then f := f or 4;
  if pos('STATIC',s)>0       then f := f or 8;
  if pos('FINAL',s)>0        then f := f or 16;
  if pos('SYNCHRONIZED',s)>0 then f := f or 32;
  if pos('SUPER',s)>0        then f := f or 32;
  if pos('VOLATILE',s)>0     then f := f or 64;
  if pos('TRANSIENT',s)>0    then f := f or 128;
  if pos('NATIVE',s)>0       then f := f or 256;
  if pos('INTERFACE',s)>0    then f := f or 512;
  if pos('ABSTRACT',s)>0     then f := f or 1024;
  flags := f;
end;

{------}

procedure StackMap(typ : byte; cp_num : word;  byteCodeOffs : word; loc_or_stack : byte);
begin
  byteCodeOffs := swap2(byteCodeOffs);
  cp_num := swap2(cp_num);
  if (cf.byteCodeOffsPtr^<>byteCodeOffs)
  or ((cf.loc_or_stack<>loc_or_stack) and (loc_or_stack = 0)) then  {new Entry}
  begin
    cf.stackMapEntries^:= swap2(swap2(cf.stackMapEntries^)+1);
    cf.byteCodeOffsPtr := pointer(@cf.StackMap^[cf.psm]);
    cf.byteCodeOffsPtr^:= byteCodeOffs;
    inc(cf.psm,2);
    cf.numLocStackPtr := pointer(@cf.StackMap^[cf.psm]);
    cf.numLocStackPtr^:= 0;
    inc(cf.psm,2);
  end;
  if (cf.loc_or_stack<>loc_or_stack) and (loc_or_stack = 1) then
  begin
    cf.numLocStackPtr := pointer(@cf.StackMap^[cf.psm]);
    cf.numLocStackPtr^:= 0;
    inc(cf.psm,2);
  end;
  cf.loc_or_stack := loc_or_stack;
  cf.numLocStackPtr^:= swap2(swap2(cf.numLocStackPtr^)+1);
  cf.StackMap^[cf.psm] := typ;
  inc(cf.psm);
  pw1:=pointer(@cf.StackMap^[cf.psm]);
  pw1^:=cp_num;
  inc(cf.psm,2);
end;


procedure interfac(s : string);
{var s2 : string;{}
begin
  {s2:='';
  for i := 1 to length(s) do
    if not (s[i] in ['/']) then s2:=s2+s1[i]
      else s2:=s2+'_';
  i:=constadd(CONSTANT_Class,s2,s1);{}
  i:=constfind(CONSTANT_Class,s,0,0,0,0,0);
  if i=0 then error('class <'+s+'> not found');
  pw1:=pointer(@cf.interfaces^[cf.pi]);
  pw1^:=swap2(i);
  inc(cf.pi,2);
  inc(cf.interfaces_count);
end;


procedure field(f : word;  s : string); {pascal; {- Delphi,  -}
begin
  pw1:=pointer(@cf.field_info^[cf.pf]);           {acces flags}
  pw1^:=swap2(f);
  inc(cf.pf,2);
  {}
  i:=constfind(CONSTANT_NameAndType,s,0,0,0,0,0);
  if i=0 then error('NameAndType <'+s+'> not found');
  pw1:=pointer(@cf.field_info^[cf.pf]);           {name index}
  pw2:=pointer(@cf.cp_info^[cf.pvar+1]); {cf.pvar -  }
  pw1^:=pw2^;
  inc(cf.pf,2);
  {}
  pw1:=pointer(@cf.field_info^[cf.pf]);           {signature index}
  pw2:=pointer(@cf.cp_info^[cf.pvar+3]);
  pw1^:=pw2^;
  inc(cf.pf,2);
  {}
  pw1:=pointer(@cf.field_info^[cf.pf]);           {attributes count}
  pw1^:=swap2(0);
  inc(cf.pf,2);
  inc(cf.fields_count);
end;


procedure localvariabletable(s1,s2 : string); {pascal; {- Delphi,  -}
begin
  cf.vartab^[cf.ntab].name:=s1;
  cf.vartab^[cf.ntab].typ:=s2;
  inc(cf.ntab);
end;


procedure method(f : word;  s1,s2 : string); {pascal; {- Delphi,  -}
begin
  pw1:=pointer(@cf.method_info^[cf.pm]);           {acces flags}
  pw1^:=swap2(f);
  inc(cf.pm,2);
  i:=constadd(CONSTANT_Utf8,'',s1,0);
  pw1:=pointer(@cf.method_info^[cf.pm]);           {name index}
  pw1^:=swap2(i);
  inc(cf.pm,2);
  i:=constadd(CONSTANT_Utf8,'',s2,0);
  pw1:=pointer(@cf.method_info^[cf.pm]);           {signature index}
  pw1^:=swap2(i);
  inc(cf.pm,2);
  pw1:=pointer(@cf.method_info^[cf.pm]);           {attributes count}
  pw1^:=swap2(1);
  inc(cf.pm,2);
  i:=constadd(CONSTANT_Utf8,'','Code',0);
  pw1:=pointer(@cf.method_info^[cf.pm]);           {attribute_name}
  pw1^:=swap2(i);
  inc(cf.pm,2);
  cf.attribute_lengthtPtr:=pointer(@cf.method_info^[cf.pm]);{attribute_length}
  inc(cf.pm,4);
  cf.attribute_lengthtPtr^:=cf.pm; {  ,   }
  cf.maxStack:=pointer(@cf.method_info^[cf.pm]);           {max_stack}
  cf.maxStack^:= 0;
  cf.curStack := 0;
  {pw1^:=swap2(10); {}
  inc(cf.pm,2);
  cf.max_localsPtr:=pointer(@cf.method_info^[cf.pm]); {max_locals}
  inc(cf.pm,2);
  cf.code_lengthPtr:=pointer(@cf.method_info^[cf.pm]); {code_length}
  inc(cf.pm,4);
  cf.code_lengthPtr^:=cf.pm; {  ,   }
  cf.ntab := 0;              {  }
  cf.stackMapEntries := pointer(@cf.stackMap^[0]);
  cf.byteCodeOffsPtr := pointer(@cf.stackMap^[2]);
  cf.psm := 2;   {skip 2 bytes (stackMapEntries)}
  cf.loc_or_stack :=0;
  fillChar(cf.vartab^,$FFFF,0);
  fillChar(cf.stackMap^, $1000, 0);
end;


procedure endmethod;
var
  attrCount :^word;
begin
  cf.code_lengthPtr^:=swap4(cf.pm-cf.code_lengthPtr^);  {  }
  cf.max_localsPtr^:= swap2(cf.ntab);  {   }
  cf.maxStack^:= swap2(cf.maxStack^);  { max- }
  pw1:=pointer(@cf.method_info^[cf.pm]);      {exception_table=0}
  pw1^:=swap2(0);
  inc(cf.pm,2);
  attrCount:=pointer(@cf.method_info^[cf.pm]);      {attributes=1}
  attrCount^:=swap2(0);
  inc(cf.pm,2);
  if (cf.ntab>0) then
  begin
    attrCount^:=swap2(swap2(attrCount^)+1);
    i:=constadd(CONSTANT_Utf8,'','LocalVariableTable',0); {..}
    pw1:=pointer(@cf.method_info^[cf.pm]);
    pw1^:=swap2(i);
    inc(cf.pm,2);
    pl1:=pointer(@cf.method_info^[cf.pm]);      {attribyte_length}
    pl1^:=swap4(cf.ntab*10+2);
    inc(cf.pm,4);
    pw1:=pointer(@cf.method_info^[cf.pm]);      {table_length}
    pw1^:=swap2(cf.ntab);
    inc(cf.pm,2);
    for j := 0 to cf.ntab-1 do
    begin
      pw1:=pointer(@cf.method_info^[cf.pm]);    {start_pc    }
      pw1^:=swap2(0);
      inc(cf.pm,2);
      pw1:=pointer(@cf.method_info^[cf.pm]);    {length    }
      i:=swap4(cf.code_lengthPtr^);
      pw1^:=swap2(i);
      inc(cf.pm,2);
      i:=constadd(CONSTANT_Utf8,'',cf.vartab^[j].name,0); { }
      pw1:=pointer(@cf.method_info^[cf.pm]);
      pw1^:=swap2(i);
      inc(cf.pm,2);
      i:=constadd(CONSTANT_Utf8,'',cf.vartab^[j].typ,0); { }
      pw1:=pointer(@cf.method_info^[cf.pm]);
      pw1^:=swap2(i);
      inc(cf.pm,2);
      pw1:=pointer(@cf.method_info^[cf.pm]);    {slot -    }
      pw1^:=swap2(j);
      inc(cf.pm,2);
    end;
  end;
  if (cf.psm>4) then
  begin
    if (cf.loc_or_stack<>1) then   {  }
    begin
      cf.numLocStackPtr := pointer(@cf.StackMap^[cf.psm]);
      cf.numLocStackPtr^:= 0;
      inc(cf.psm,2);
    end;
    attrCount^:=swap2(swap2(attrCount^)+1);
    i:=constadd(CONSTANT_Utf8,'','StackMap',0);
    pw1:=pointer(@cf.method_info^[cf.pm]);
    pw1^:=swap2(i);
    inc(cf.pm,2);
    pl1:=pointer(@cf.method_info^[cf.pm]);      {attribyte_length}
    pl1^:=swap4(cf.psm{+2{});
    inc(cf.pm,4);
    (*
    pw1:=pointer(@cf.method_info^[cf.pm]);      {Entries count}
    pw1^:=cf.stackMapEntries^;
    inc(cf.pm,2);
    *)
    Move(cf.stackMap^[0], cf.method_info^[cf.pm], cf.psm);
    inc(cf.pm, cf.psm);
  end;
  cf.attribute_lengthtPtr^ := swap4(cf.pm-cf.attribute_lengthtPtr^);
  inc(cf.methods_count);  { }
end;


procedure attribute;
begin
  { ,   "SourceFile"  ...}
end;


function argSizes(s : string) : integer;
var
  i,n,len : integer;
begin
  len:=length(s);
  n:=1;
  i:=2;
  repeat
    case s[i] of
     'J','D': inc(n,2);
     'L': begin
            repeat
              inc(i);
              if (i>len) then error('(end of str) Bad parametr: "'+s+'"');
            until (s[i]=';');
            inc(n);
          end;
     '[': begin
            repeat
              inc(i);
              if (i>len) then error('(end of str) Bad parametr: "'+s+'"');
            until (s[i]<>'[');
            if s[i] in ['D','J'] then dec(n);
          end;
     ')': begin
            n:=n shl 2;
            case s[i+1] of
             'V'    : argSizes := n;
             'D','J': argSizes := n or 2;
             else     argSizes := n or 1;
            end;
            exit;
          end;
     else inc(n);
    end;
    inc(i);
    if (i>len) then error('(end of str) Bad parametr: "'+s+'"');
  until false;
end;


procedure bytecode(s : string);
var
  st  : array[0..15] of char;
  s2  : string;
  j,k : word;
  op  : byte;
  c   : char;
begin
  j:=0;
  while j<length(s) do
  begin
    st[j] := s[j+1];
    inc(j);
  end;
  while j<=15 do
  begin
    st[j] := #32;
    inc(j);
  end;
  for op := 0 to 255 do if jbc[op].s=st then break;
  if op=255 then error('don''t know command: <'+s+'>');
  cf.method_info^[cf.pm]:=op;
  inc(cf.pm);
  {s:='AAAAAAAAAAAAAAAABCBCCBBBBBAAAAAAAAAAAAAAAAAAAAAAAAAAAABBBBBAAAAAAAAA'+
      'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACAAA'+
      'AAAAAAAAAAAAAAAAACCCCCCCCCCCCCCCCBZZAAAAAACCCCCCCECCBCAACCAAzDCCEEA';
  opLength := ord(s[op+1])-ord('A')+1;{}
  {s:='EFFFFFFFFGGFFFGGFFFEEFGFGFEEEEEEEEEEEEEEEEEEEEDEDEDDDDDCDCDEEEEEEEEE'+
      'EEEEEEEEEEEBABABBBBDCFFFGGGEDCDCDCDCDCDCDCDCDCDCEEEEDDDDDDDCDCDCEFEF'+
      'DDEEFFDEDEEEBDDBBDDDDDDCCCCCCCCEFEDDDCDCDEEEEEEEEEEFEEEEEEDDEEDDEE';
  cf.curStack := cf.curStack + (ord(s[op+1]) - ord('E'));{}
  {s:='AAAAAAAAAAAAAAAABCKLLDDDDDEEEEEEEEEEEEEEEEEEEEAAAAAAAADDDDDEEEEEEEEE'+
      'EEEEEEEEEEEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAMAAA'+
      'AAAAAAAAAAAAAAAAAIIIIIIIIIIIIIIIIDNOAAAAAAGGGGGGGHAFBFAAFFAAQPIIJJII'+
      'IIIIIIIIIIIIIIII';
  typ_par := ord(s[op+1]) - ord('A');{}
  cf.curStack := cf.curStack+jbc[op].b[3];
  for j:=0 to 2 do
  case jbc[op].b[j] of
    0: begin end;
    nb:   {1  }
      begin
        i:=getn;
        cf.method_info^[cf.pm]:=byte(i);
        inc(cf.pm);
        {stack int}
        if (op=$C5) then  inc(cf.curStack,1-i);  {stack MultiANewArray}
      end;
    ns:   {1  }
      begin
        cf.method_info^[cf.pm]:={byte}shortInt(getn);
        inc(cf.pm);
      end;
    nw:   {2  }
      begin
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(word(getn));
        inc(cf.pm,2);
      end;{??????}
    ni:   {2  }
      begin
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2({word}integer(getn));
        inc(cf.pm,2);
        {stack int}
      end;
    cb:   {1     }
      begin
        {i:=constfind(CONSTANT_any,'',gets,0);{}
        i:=constadd(CONSTANT_String,'',gets,0);{}
        cf.method_info^[cf.pm]:=i;
        inc(cf.pm);
        {stack ldc}
      end;
    cw:   {2     2-  }
      begin
        i:=constadd(CONSTANT_Integer,gets,'',0);
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(i);
        inc(cf.pm,2);
        {stack ldc}
      end;
    cl:   {2     2-  }
      begin
        i:=constadd(CONSTANT_Long,gets,'',0);
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(i);
        inc(cf.pm,2);
        {stack ldc}
      end;
    cp:   {2            
                 -    64-   32-}
      begin
        s:=gets;
        skipSpaces;
        if ch=':' then begin getc; s2:=gets; i:=constadd(CONSTANT_Fieldref,s,'',constadd(CONSTANT_NameAndType,s2,getb,0)); end
          else begin skip('.'); s2:=gets; i:=constadd(CONSTANT_Fieldref,s,s2,0); end;
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(i);
        inc(cf.pm,2);
        {stack field}
        pw1:=pointer(@cf.cp_info^[cf.pvar+1+2]);
        i:=constfind(CONSTANT_NameAndType,'',swap2(pw1^),0,0,0,0); {  NameAndType}
        pw1:=pointer(@cf.cp_info^[cf.pvar+1+2]);
        i:=constfind(CONSTANT_Utf8,'',swap2(pw1^),0,0,0,0);   {   }
        c:=chr(cf.cp_info^[cf.pvar+1+2]);  {   -}
        case (op) of
          $B2: if (c in ['D','J']) then inc(cf.curStack,2) else inc(cf.curStack); {GETSTATIC}
          $B3: if (c in ['D','J']) then dec(cf.curStack,2) else dec(cf.curStack); {PUTSTATIC}
          $B4: if (c in ['D','J']) then inc(cf.curStack); {GETFIELD}
          else if (c in ['D','J']) then dec(cf.curStack,3) else dec(cf.curStack,2); {PUTFIELD $B5:}
        end;
      end;
    cv:   {2       -  }
      begin
        s:=gets;
        skipSpaces;
        if ch=':' then begin getc;
        s2:=gets;i:=constadd(CONSTANT_Methodref,s,'',constadd(CONSTANT_NameAndType,s2,getb,0));end
          else begin skip('.'); s2:=gets; i:=constadd(CONSTANT_Methodref,s,s2,0); end;
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(i);
        {pw1^:=swap2(constfind(CONSTANT_Methodref,gets,0,0,0,0));}
        inc(cf.pm,2);
        {stack method}
        pw1:=pointer(@cf.cp_info^[cf.pvar+1+2]);
        i:=constfind(CONSTANT_NameAndType,'',swap2(pw1^),0,0,0,0); {  NameAndType}
        pw1:=pointer(@cf.cp_info^[cf.pvar+1+2]);
        i:=constfind(CONSTANT_Utf8,'',swap2(pw1^),0,0,0,0);   {   }
        inc(cf.pvar);
        pw1:=pointer(@cf.cp_info^[cf.pvar]);
        inc(cf.pvar,2);
        s:='';
        i := swap2(pw1^);
        while i>0 do
        begin
          s:=s+chr(cf.cp_info^[cf.pvar]);  {   -}
          inc(cf.pvar);
          dec(i);
        end;
        i := argSizes(s);
        inc(cf.curStack,(i and $03)-(i shr 2));
        if cf.curStack<0 then
        writeln;
        if (op=$B8) then inc(cf.curStack);  {INVOKESTATIC}
      end;
    cn:   {2 -     }
      begin
        i:=constfind(CONSTANT_any,gets,0,0,0,0,0);
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(i);
        inc(cf.pm,2);
        {stack type}
      end;
    ck:   {2    }
      begin
        s:=gets;
        {s2:='';
        for i := 1 to length(s) do
          if not (s[i] in ['/']) then s2:=s2+s[i]
             else s2:=s2+'_';{}
        i:=constadd(CONSTANT_Class,{s2}'',s,0);
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(i);
        inc(cf.pm,2);
        {stack type}
      end;
    cs:   {2    }
      begin
        i:=constadd(CONSTANT_String,s,'',0);
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(i);
        inc(cf.pm,2);
        {stack type}
      end;
    li0:  {1  const}
      begin
        {stack var}
      end;
    lii:  {1     }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    lil:  {     }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    lif:  {      }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    lid:  {      }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    lio:  {     }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    si0:  {1  const}
      begin
        {stack var}
      end;
    sii:  {     }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    sil:  {     }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    sif:  {      }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    sid:  {     }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    sio:  {     }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    ac:   {    }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack iinc}
      end;
    of2:  {16-  }
      begin
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(integer(getn));
        inc(cf.pm,2);
        {stack jump}
      end;
    of4:  {32-  }
      begin
        pl1:=pointer(@cf.method_info^[cf.pm]);
        pl1^:=swap4(longInt(getn));
        inc(cf.pm,4);
        {stack jump}
      end;
    ofp2: {16-     }
      begin
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(integer(getn));
        inc(cf.pm,2);
        {stack jump}
      end;
    ofp4: {32-     }
      begin
        pl1:=pointer(@cf.method_info^[cf.pm]);
        pl1^:=swap4(longInt(getn));
        inc(cf.pm,4);
        {stack jump}
      end;
    rtb:  {8-     -  }
      begin
        cf.method_info^[cf.pm]:=byte(getn);
        inc(cf.pm);
        {stack var}
      end;
    rtw:  {16-  }
      begin
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(word(getn));
        inc(cf.pm,2);
      end;
    wide:
      begin
        bytecode(gets);
        pw1:=pointer(@cf.method_info^[cf.pm]);
        pw1^:=swap2(word(getn));
        inc(cf.pm,2);
      end;
    tbs:
      begin
        while ((cf.pm-cf.code_lengthPtr^) mod 4)<>0 do
        begin
          cf.method_info^[cf.pm]:=0;
          inc(cf.pm);
        end;
        for i:=0 to 7 do
        begin
          pl1:=pointer(@cf.method_info^[cf.pm]);
          pl1^:=swap4(longInt(getn));
          inc(cf.pm,4);
        end;
        {stack TableSwitch}
      end;
    lks:
      begin
        while ((cf.pm-cf.code_lengthPtr^) mod 4)<>0 do
        begin
          cf.method_info^[cf.pm]:=0;
          inc(cf.pm);
        end;
        pl1:=pointer(@cf.method_info^[cf.pm]);
        pl1^:=swap4(longInt(getn));
        inc(cf.pm,4);
        {}
        pl1:=pointer(@cf.method_info^[cf.pm]);
        pl1^:=swap4(longInt(getn));
        inc(cf.pm,4);
        k:=pl1^;
        for i:=1 to k do
        begin
          pl1:=pointer(@cf.method_info^[cf.pm]);
          pl1^:=swap4(longInt(getn));
          inc(cf.pm,4);
        end;
        for i:=1 to k do
        begin
          pl1:=pointer(@cf.method_info^[cf.pm]);
          pl1^:=swap4(longInt(getn));
          inc(cf.pm,4);
        end;
        {stack LookupSwitch}
      end;
    else writeln('Error: str:[', op, ',', j, ']=', jbc[op].b[j]);
  end;
  if (cf.curStack > cf.maxStack^) then cf.maxStack^:=cf.curStack;
end;

{------}

procedure out(var b; n : integer);
var
  c : integer;
begin
  blockWrite(f,b,n,c);
  if c<>n then error('write-file');
end;



begin
  getMem(cf.cp_info,            $FFFF);
  getMem(cf.interfaces,         $7FFF);
  getMem(cf.field_info,         $7FFF);
  getMem(cf.method_info,        $FFFF);
  getMem(cf.attribute_info,     $7FFF);
  getMem(cf.vartab,             $FFFF);
  getMem(cf.stackMap,           $1000);
  fillChar(cf.cp_info^,         $FFFF, 0);
  fillChar(cf.interfaces^,      $7FFF, 0);
  fillChar(cf.field_info^,      $7FFF, 0);
  fillChar(cf.method_info^,     $FFFF, 0);
  fillChar(cf.attribute_info^,  $7FFF, 0);
  fillChar(cf.vartab^,          $FFFF, 0);
  fillChar(cf.stackMap^,        $1000, 0);
  cf.constant_pool_count := 0;
  cf.interfaces_count := 0;
  cf.fields_count := 0;
  cf.methods_count := 0;
  cf.attributes_count := 0;
  cf.pc := 0;
  cf.pi := 0;
  cf.pf := 0;
  cf.pm := 0;
  cf.pa := 0;
  assign(f,'j.txt');
  reset(f,1);
  strNum := 1;
  strPos := 0;
  ch:=#32;
  s:=gets;
  if s<>'class' then error('first string -> this class name');
  repeat
    if (s='class')                   then constadd(CONSTANT_Class,gets,getb,0)
    else if (s='nameandtype')        then constadd(CONSTANT_NameAndType,gets,getb,0)
    else if (s='integer')            then constadd(CONSTANT_Integer,gets,'',getn)
    else if (s='string')             then constadd(CONSTANT_Utf8,gets,getb,0)
    else if (s='interface')          then interfac(gets)
    else if (s='field')              then field(flags(getb),gets)
    else if (s='method')             then method(flags(getb),gets,getb)
    else if (s='localvariabletable') then localvariabletable(gets,getb)
    else if (s='stackmap')           then begin {j:=getn;} stackMap({j}CONSTANT_Class,
                                             constadd({j}CONSTANT_Class,'',getb,0), getn, getn); end
    else if (s='endmethod')          then endmethod
    else if (s='attribute')          then attribute
    else bytecode(s);
    {skip(#10);   {   - (..   -  )}
    s:=gets;
  until eof(f) or (s='');
  close(f);
  {====================}
  assign(f,'hello.cla');
  rewrite(f,1);
  cf.magic:=swap4($CAFEBABE);    {longInt}
  out(cf.magic,4);
  cf.minor_version:=swap2(0);    {word}
  out(cf.minor_version,2);
  cf.major_version:=swap2(47);   {word}
  out(cf.major_version,2);
  inc(cf.constant_pool_count);  {-    !?}
  i := swap2(cf.constant_pool_count); {word}
  out(i,2);
  cf.pc:=0;                        {^tarr[constant_pool_count-1]}
  i:=1;
  while (i<cf.constant_pool_count) do
  begin
    inc(cf.pc, cf.cp_info^[cf.pc]+1);
    out(cf.cp_info^[cf.pc],1);
    case cf.cp_info^[cf.pc] of
      CONSTANT_Class,CONSTANT_String:
        begin
          inc(cf.pc);
          pw1:=pointer(@cf.cp_info^[cf.pc]);
          out(pw1^,2);
          inc(cf.pc,2);
        end;
      CONSTANT_Fieldref,CONSTANT_Methodref,CONSTANT_InterfaceMethodref,CONSTANT_NameAndType:
        begin
          inc(cf.pc);
          pw1:=pointer(@cf.cp_info^[cf.pc]);
          out(pw1^,2);
          inc(cf.pc,2);
          pw1:=pointer(@cf.cp_info^[cf.pc]);
          out(pw1^,2);
          inc(cf.pc,2);
        end;
      CONSTANT_Integer,CONSTANT_Float:
        begin
          inc(cf.pc);
          pl1:=pointer(@cf.cp_info^[cf.pc]);
          out(pl1^,4);
          inc(cf.pc,4);
        end;
      CONSTANT_Long,CONSTANT_Double:
        begin
          inc(cf.pc);
          pl1:=pointer(@cf.cp_info^[cf.pc]);
          out(pl1^,4);
          inc(cf.pc,4);
          pl1:=pointer(@cf.cp_info^[cf.pc]);
          out(pl1^,4);
          inc(cf.pc,4);
          inc(i);        {   2-   constant_pool}
        end;
      CONSTANT_Utf8, CONSTANT_Unicode:
        begin {null=$0000, 1b=$0001-$007F,2b=$0008-$07FF,3b=$0800-$FFFF{}
          inc(cf.pc);
          pw1:=pointer(@cf.cp_info^[cf.pc]);
          inc(cf.pc,2);
          out(pw1^,2);
          for j:=swap2(pw1^) downto 1 do
          begin
            out(cf.cp_info^[cf.pc],1);
            inc(cf.pc);
          end;
        end;
    end;
    inc(i);
  end;
  cf.access_flags:=swap2(ACC_PUBLIC or ACC_SUPER);   {word}
  out(cf.access_flags,2);
  {i:=constadd(CONSTANT_Utf8,'','hello',0);
  i:=constfind(CONSTANT_Class,'',i,0,0,0);{}
  i:=2;  {<- first class - my current class}
  cf.this_class:=swap2(i);       {word}
  out(cf.this_class,2);
  i:=constadd(CONSTANT_Utf8,'','javax/microedition/midlet/MIDlet',0);
  i:=constfind(CONSTANT_Class,'',0,i,0,0,0);
  cf.super_class:=swap2(i);      {word}
  out(cf.super_class,2);
  cf.interfaces_count:=swap2(cf.interfaces_count); {word}
  out(cf.interfaces_count,2);
  out(cf.interfaces^,cf.pi);
  cf.fields_count:=swap2(cf.fields_count); {word}
  out(cf.fields_count,2);
  out(cf.field_info^,cf.pf);
  cf.methods_count:=swap2(cf.methods_count); {word}
  out(cf.methods_count,2);
  out(cf.method_info^,cf.pm);
  cf.attributes_count:=swap2(0); {word}
  out(cf.attributes_count,2);
  out(cf.attribute_info^,cf.pa);
  close(f);
  freeMem(cf.stackMap,        $1000);
  freeMem(cf.vartab,          $FFFF);
  freeMem(cf.attribute_info,  $7FFF);
  freeMem(cf.method_info,     $FFFF);
  freeMem(cf.field_info,      $7FFF);
  freeMem(cf.interfaces,      $7FFF);
  freeMem(cf.cp_info,         $FFFF);
end.
